package myUIDelegateExample2;

import javax.swing.ComboBoxModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.DefaultListSelectionModel;
import javax.swing.ListModel;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListDataListener;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelListener;
import javax.swing.table.*;

import a1MVC.Datum;

import java.io.*;
import java.util.*;

/**
 * The WorldRecordsDataModel implements a model of the data that describes the
 * world records, which consists of a number of events, each of which has an
 * event name, a time, a record holder (the person who achieved that time), a
 * nation (the country of the person who established the record), a place (where
 * the record was established), and a date.
 */
public class MyDataModelForComboBoxData implements ComboBoxModel {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	DefaultComboBoxModel wrappedComboBoxModel;

	final String[] SIGNS = { "Aries\tMarch 21-April 19",
			"Taurus\tApril 20-May 20", "Gemini\tMay 21-June 20",
			"Cancer\tJune 21-July 22", "Leo\tJuly 23- Aug. 22",
			"Virgo\tAug. 23-Sept. 22", "Libra\tSept. 23- Oct. 22",
			"Scorpio\tOct. 23- Nov. 21", "Sagittarius\tNov. 22-Dec. 21",
			"Capricorn\tDec. 22-Jan. 19", "Aquarius\tJan. 20-Feb 18",
			"Pisces\tFeb. 19-March 20" };

	private static final int REQD_NUM_FIELDS = 6;
	private static final int COUNTRY_FIELD_NUM = 3;

	/**
	 * presently, this constructor creates an instance of a
	 * WorldRecordsDataModel that is populated with data contained in the passed
	 * file, of which the first row provide the header options, and the tokens
	 * are delimited by commas
	 * 
	 * @throws IOException
	 */
	public MyDataModelForComboBoxData() {
		wrappedComboBoxModel = new DefaultComboBoxModel(SIGNS);
	}

	// ///////////////
	public void addListDataListener(ListDataListener arg0) {
		// for (ListDataListener l : listModel.getListDataListeners()) {
		// System.out.println("&&&&" + l);
		// }
		System.out.println("adding ListDataListener: " + arg0);
		wrappedComboBoxModel.addListDataListener(arg0);
	}

	public Object getElementAt(int arg0) {
		return wrappedComboBoxModel.getElementAt(arg0);
	}

	public int getSize() {
		return wrappedComboBoxModel.getSize();
	}

	public void removeListDataListener(ListDataListener arg0) {
		// System.out.println("removing ListDataListener: " + arg0);
		wrappedComboBoxModel.removeListDataListener(arg0);
	}

	public Object getSelectedItem() {
		return wrappedComboBoxModel.getSelectedItem();
	}

	public void setSelectedItem(Object arg0) {
		System.out.println("set selected item: " + arg0);
		wrappedComboBoxModel.setSelectedItem(arg0);
		// who has invoked me?
		try {
			throw new Exception();
		} catch (Exception e) {
			StackTraceElement[] elements = e.getStackTrace();
			String s = "";
			for (int i = elements.length-1; i >= 0; i--) {
				// for (int i = 0; i < elements.length; i++) {
				s += "\t" + elements[i] + "\n";
			}
			System.out.println("Who called the method \"setSelectedItem\"? ");
			System.out.println(s);
		}

	}
}