package myUIDelegateExample2;

import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;

/**
 * This class implements controller behaviour for the application.
 * 
 * It receives requests (from the end user) and passes them to the model and/or
 * the view via method invocation
 * 
 */
public class View1Controller implements ListDataListener {
	private View1 view;
	private MyDataModelForComboBoxData model;

	/*
	 * Creates a controller for the given view and model. @param view the view
	 * of the GUI. @param model the model of the GUI.
	 */
	public View1Controller(View1 view, MyDataModelForComboBoxData model) {
		this.view = view;
		this.model = model;
	}

	public void contentsChanged(ListDataEvent e) {
		System.out.println("contentsChanged method invoked in: "
				+ this.getClass().getName());
		System.out.println("more info about event: " + e.toString());
	}

	public void intervalAdded(ListDataEvent e) {
		System.out.println("intervalAdded method invoked in: "
				+ this.getClass().getName());
		System.out.println("more info about event: " + e.toString());
	}

	public void intervalRemoved(ListDataEvent e) {
		System.out.println("intervalRemoved method invoked in: "
				+ this.getClass().getName());
		System.out.println("more info about event: " + e.toString());
	}
}
